<?php
/*------------------------------------------------------------------------
# mod_leoaccordion_slideshow - Leo Accordion SlideShow Module
# ------------------------------------------------------------------------
# author:    LeoTheme.Com
# copyright: Copyright (C) 2011 http://www.leotheme.com. All Rights Reserved.
# @license: http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.leotheme.com
# Technical Support:  http://www.leotheme.com/contact-us/support-inquiries.html
-------------------------------------------------------------------------*/
// no direct access
defined('_JEXEC') or die;


// Include the syndicate functions only once
require_once dirname(__FILE__).DS.'helper.php';
$list = modLeoAccordionSlideShowHelper::getList( $params, $module );


$moduleHeight   =  (int)$params->get( 'module_height', '300' );
$moduleWidth    =  (int) $params->get( 'module_width', '940' );

$mainWidth  = (int) $params->get( 'main_width', 650 );
$mainHeight = (int) $params->get( 'main_height', 300 );


$perItemMinWidth = (int)$params->get( 'min_width_expanded', 196 );
$perItemWidth 	 = (int) $params->get('max_width_expanded', 650);
$spacing  		 = (int)$params->get( 'spacing', 0 );
$event  		 = $params->get( 'event', 'mouseover' );
$themeClass 	= $params->get( 'theme' , '');
$target 	= $params->get( 'open_target', 'parent' );
$class 		= $params->get( 'navigator_pos', 0 ) ? '':'lof-snleft';
$theme		= $params->get( 'theme', '' ); 
$css3           = $params->get('enable_css3','1')?'lof-css3':''; 
$contentSlider = $params->get('content_slider', 'decription');
$group=$params->get('group','content');
modLeoAccordionSlideShowHelper::loadMediaFiles( $params, $module, $theme );

$descMode = $params->get('desc-mode','slideup'); 
$url = JURI::base()."modules/".$module->module."/assets/";
$layout = trim($theme).DS.'default';
require( JModuleHelper::getLayoutPath($module->module, $layout ) );
 
 
?>
 <script>
 	jQuery.noConflict();
	var settings = {
		orientation: '<?php echo $params->get('direction','horizontal') ?>',
		componentWidth: <?php echo $moduleWidth;?>,
		componentHeight: <?php echo $moduleHeight;?>,
		visibleItems:<?php echo $params->get("visible_items",5); ?>,
		hideTitleOnOpen: <?php echo $params->get("hide_title_on_open",1); ?>,
		unSelectableCaptions: true,
		videoAutoplay: <?php echo $params->get("auto_play_video",0);?>,
		slideshowOn: false,
		useGlobalDelay: true,
		slideshowDelay: <?php echo $params->get("interval",5000);?>,
		randomPlay: <?php echo $params->get("random_show",0); ?>,
		includeVideoInSlideshow: false,
		openYoutubeOnBuffering: false,
		openOnRollover: <?php echo (int) $params->get('event',1); ?>,
		openOnClickAllSlidesButtonMode: false,
		useScroll: false,
		scrollOrientation: 'horizontal',
		scrollDraggerOverColor: '#658',
		useControls: true,
		openSlideNum: <?php echo (int)$params->get("start_slide",0); ?>,
		keepSelection: <?php echo (int)$params->get("is_sticky",0);?>,
		transitionTime: <?php echo (int)$params->get("duration",1000);?>,
		transitionEase: '<?php echo $params->get("effect", "easeOutQuint"); ?>',
		playBtnUrl:'<?php echo $url;?>play2.png',
		closeTextUrl:'<?php echo $url;?>close.png',
		controls_pause_url:'<?php echo $url;?>controls_pause.gif',
		controls_play_url:'<?php echo $url;?>controls_play.gif',
		useBorder: false,
		borderSize: 5,
		borderColor: '#ffffff',
		useKeyboardNavigation: true,
		videoDisablesAllNavigation: false
	};
	jQuery(window).load(function() {
		jQuery.accordionGallery('#sliderWrapper<?php echo $module->id;?>', settings);   
	});
</script>
